/**********************************************************************
*  Project     : Windows hiAirV2 VC Example Applications
*  Description : notify2 <Ip Addr> <Login> <Pw> <TelNum> <Message>
*  VC compiler : use winsock, include winsock.h and use wsock32.lib
**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <winsock.h>   /* For WinSocket */

#define SERV_PORT			8000	/* Server Port*/ 

/* ǰeƪstruct */
struct Send_Msg{
   unsigned	char  msg_type;		//TA
   unsigned	char  msg_coding;	//TsX
   unsigned	char  msg_priority;	//Tuv
   unsigned	char  msg_country_code; //X
   unsigned	char  msg_set_len;	//msg_set[] Te
   unsigned	char  msg_content_len;	//msg_content[]Te
             	char  msg_set[100];	//TƳ]w
              	char  msg_content[160];	//²Te
};


/* ƪstruct */
struct Ret_Msg{
   unsigned	char  ret_code ;	//^ǰTNX
   unsigned	char  ret_coding ; 	//TsX
   unsigned	char  ret_set_len;	//ret_set[] Te
   unsigned	char  ret_content_len;	//ret_content[]Te
           	char  ret_set[80];	//T
           	char  ret_content[160];	//MessageID or Ț^Ǫ²Te
};

/* rۥ[禡 */
int FillMsg(char *src, char *target, int n)
{
   int i,len;
   len = strlen(target);
   for(i=0; i<len; i++)
      src[n++] = target[i];
   src[n++] = '\0';
   return(n);
}

/* LogFile */
void LogMessage(char *Login, char *TelNum, char *MsgId, int status, char *Msg)
{
   char str_time[50];
   char TmpStr[300];
   time_t tnow;
   struct tm *lctime;
   FILE *fp;
   if( (fp=fopen("notify2.log","a+")) == NULL ){
	  printf("write into logfile fail!\n");
      return;
   }
   time(&tnow);
   lctime = localtime(&tnow);
   strftime(str_time, 80, "%Y%m%d.%H%M%S", lctime);
   sprintf(TmpStr,"%s %8s %10s %8s %3d %s\n", str_time, Login, TelNum, MsgId, status, Msg);
   fputs(TmpStr, fp);
   fclose(fp);
}


void main(int argc, char *argv[])     
{

   SOCKET  clientSD = -1;
   WSADATA WSAData;
   SOCKADDR_IN srvAddr ;

   struct Send_Msg sendMsg;
   struct Ret_Msg retMsg;

   int i,iPos,nRet,nRet1;
   char SERVIP[20]="";		/* AIP */
   char Login[20]="";		/* b */
   char Pw[20]="";			/* KX */
   char TelNum[20]="";		/* X */
   char Send_Type[3]="";    /*]wǰeΦ 01: Yɶǰe 03:wǰe */
   char Msg_Content[160]="";/* ²Te*/
   char MsgID[160]="";		/* MessageID*/
   char ErrMsg[50]="";

   if(argc<6)
   {
      printf("\nUsage : notify2 <Ip Addr> <Login> <Pw> <TelNum> <Msg> ");
      printf("\n <ex>: notify2 202.39.54.130 test test1 0932xxxxxx message");
      printf("\nOutput: notify2.log");
      printf("\n <ex>: <Date.Time> <Login> <TelNum> <MessageId> <Status> <Msg>\n");
	  LogMessage(Login,TelNum,MsgID,-1,"Fail:Argument_Error!");
      exit(0);
   }

   strcpy(SERVIP, argv[1]);
   strcpy(Login, argv[2]);
   strcpy(Pw, argv[3]);
   strcpy(TelNum, argv[4]);
   strcpy(Msg_Content, "");       

   for(i=5; i<argc; i++){
      strcat(Msg_Content,argv[i]);
      strcat(Msg_Content," ");
   }
   Msg_Content[159] = '\0';

   /* ]wAIP}TG */
   srvAddr.sin_family = AF_INET;
   srvAddr.sin_port = htons((u_short)SERV_PORT);
   srvAddr.sin_addr.s_addr = inet_addr((LPCTSTR)SERVIP);

   /* Initialize the Winsock() */
   if (WSAStartup((WORD)((1 << 8) | 1), (LPWSADATA)&WSAData)!=0) {
	  printf("WSAStartup error!\n"); 
 	  LogMessage(Login,TelNum,MsgID,-2,"WSAStartup error!");
	  exit(0);
   }

   /* suA */
   if((clientSD=socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
   {
      /* socket create error, program halt */
      printf("socket create error!\n");
	  LogMessage(Login,TelNum,MsgID,-3,"socket create error!");
	  exit(0);
   }
   if(connect(clientSD, (LPSOCKADDR)&srvAddr, sizeof(srvAddr)) != 0)
   {  /* can not connect server, program halt*/
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
      printf("socket connect error!\n");
	  LogMessage(Login,TelNum,MsgID,-4,"socket connect error!");
	  exit(0);
   }

/***** b/KXT{ *****/

   memset((char *)&sendMsg, 0, sizeof(sendMsg));
   sendMsg.msg_type = 0; /* ˬdbKXtype*/
   iPos = 0; 
   iPos = FillMsg(&sendMsg.msg_set[0], Login, iPos);
   iPos = FillMsg(&sendMsg.msg_set[0], Pw, iPos);
   sendMsg.msg_set_len = iPos;
   
   if(nRet=send(clientSD, (char *)&sendMsg, sizeof(sendMsg), 0) == SOCKET_ERROR)
   {  /* socket send error*/
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
	  printf("socket send error!\n");
	  sprintf(ErrMsg,"socket sned error! nRet=%d\n",nRet);
	  LogMessage(Login,TelNum,MsgID,-5,ErrMsg);
	  exit(0);
   }

   memset((char *)&retMsg, 0, sizeof(retMsg)) ;
   nRet = recv(clientSD, (char *)&retMsg, sizeof(retMsg), 0) ;
   if((nRet == SOCKET_ERROR) || (nRet <= 0))
   {      /* receive error or server close connection */

	  nRet1=WSAGetLastError();
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
	  printf("socket receive error! nRet=%d,nRet1\n",nRet,nRet1);
	  sprintf(ErrMsg,"socket receive error! nRet=%d,nRet1=%d\n",nRet,nRet1);
	  LogMessage(Login,TelNum,MsgID,-6,ErrMsg);
	  exit(0);
   }

   if(retMsg.ret_code != 0)  /*  checking error */
   {
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
	  printf("ID/Passwd Check Error!\n");
	  LogMessage(Login,TelNum,MsgID,retMsg.ret_code,retMsg.ret_content);
	  exit(0);
   }

/***** ǰer²T *****/
   memset((char *)&sendMsg, 0, sizeof(sendMsg));   
   
   if(TelNum[0] == '+'){
	   sendMsg.msg_type = 15; /*TA 1 -> ǰer²TF 15 -> ǰe²T*/
   }else{
	   sendMsg.msg_type = 1; 
   }
   
   sendMsg.msg_coding = 1; /*TsX : 1 -> big5 sX*/
   strcpy(Send_Type,"01");  /*]wǰeΦ 01: Yɶǰe*/

   iPos = 0;   
   iPos = FillMsg(&sendMsg.msg_set[0], TelNum, iPos);/*NXJmsg_set*/   
   iPos = FillMsg(&sendMsg.msg_set[0], Send_Type, iPos);   /*NǰeΦJmsg_set*/
   sendMsg.msg_set_len = iPos;

   /*N²Tegmsg_content*/
   strcpy(sendMsg.msg_content,Msg_Content);
   sendMsg.msg_content_len = strlen(Msg_Content);
   
   if(send(clientSD, (char *)&sendMsg, sizeof(sendMsg), 0) == SOCKET_ERROR)
   {      /*  socket send error */
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
	  printf("socket send error!\n");
	  LogMessage(Login,TelNum,MsgID,-7,"socket send error!");
	  exit(0);
   }

   memset((char *)&retMsg, 0, sizeof(retMsg)) ;
   nRet = recv(clientSD, (char *)&retMsg, sizeof(retMsg), 0) ;
   if((nRet == SOCKET_ERROR) || (nRet <= 0))
   {      /* receive error or server close connection */
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
	  printf("socket receive error! nRet=%d\n",nRet);
	  LogMessage(Login,TelNum,MsgID,-8,"socket receive error!");
	  exit(0); 
   }

   if(retMsg.ret_code!=0){  /* ǰe~o S²TMessageID*/
      shutdown(clientSD, 0);  /* socket cannot send anymore */
      closesocket(clientSD);   /* close socket */
      WSACleanup();
      printf("%d %s\n",retMsg.ret_code,retMsg.ret_content);
      LogMessage(Login,TelNum,MsgID,retMsg.ret_code,retMsg.ret_content);
	  exit(0);
   }

   shutdown(clientSD, 0);  /* socket cannot send anymore */
   closesocket(clientSD);  /* close socket */
   WSACleanup();

   /* 즹  ܶǰe\ */
   strcpy(MsgID,retMsg.ret_content);
   printf("%d %s\n",retMsg.ret_code,MsgID);
   LogMessage(Login,TelNum,MsgID,retMsg.ret_code,"send success!");

}